>From 287684346feac09e17ce45a5a39645ad61e9e534 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 01/39] dinput: Introduce direct_input_device_alloc helper.

To factory device allocation and initialization.
---
 dlls/dinput/device.c              | 16 ++++++++++++++++
 dlls/dinput/device_private.h      |  3 +++
 dlls/dinput/joystick_linux.c      | 20 ++++----------------
 dlls/dinput/joystick_linuxinput.c | 16 ++++------------
 dlls/dinput/joystick_osx.c        | 19 +++----------------
 dlls/dinput/keyboard.c            | 12 +++---------
 dlls/dinput/mouse.c               | 15 ++++-----------
 7 files changed, 37 insertions(+), 64 deletions(-)

diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index 198e903fc2e..0c8d7445b08 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -1870,3 +1870,19 @@ HRESULT WINAPI IDirectInputDevice8WImpl_GetImageInfo(LPDIRECTINPUTDEVICE8W iface
     
     return DI_OK;
 }
+
+HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtblw,
+        const IDirectInputDevice8AVtbl *vtbla, const GUID *guid, IDirectInputImpl *dinput, void **out)
+{
+    IDirectInputDeviceImpl *This;
+    if (!(This = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size))) return DIERR_OUTOFMEMORY;
+    This->IDirectInputDevice8A_iface.lpVtbl = vtbla;
+    This->IDirectInputDevice8W_iface.lpVtbl = vtblw;
+    This->ref = 1;
+    This->guid = *guid;
+    InitializeCriticalSection(&This->crit);
+    This->dinput = dinput;
+    IDirectInput_AddRef(&dinput->IDirectInput7A_iface);
+    *out = This;
+    return DI_OK;
+}
diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index 2fac4f0e61e..1c727e71f46 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -86,6 +86,9 @@ struct IDirectInputDeviceImpl
     ActionMap                  *action_map;  /* array of mappings */
 };
 
+extern HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtblw,
+        const IDirectInputDevice8AVtbl *vtbla, const GUID *guid, IDirectInputImpl *dinput, void **out) DECLSPEC_HIDDEN;
+
 extern BOOL get_app_key(HKEY*, HKEY*) DECLSPEC_HIDDEN;
 extern DWORD get_config_key(HKEY, HKEY, const char*, char*, DWORD) DECLSPEC_HIDDEN;
 
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 2b26eb806d3..fd4ba4e0e71 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -473,12 +473,10 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
 
-    newDevice = HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(JoystickImpl));
-    if (newDevice == 0) {
-        WARN("out of memory\n");
-        *pdev = 0;
-        return DIERR_OUTOFMEMORY;
-    }
+    *pdev = NULL;
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, &JoystickAvt, rguid, dinput, (void **)&newDevice)))
+        return hr;
+    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
 
     newDevice->joydev = &joystick_devices[index];
     newDevice->joyfd = -1;
@@ -496,14 +494,6 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
         newDevice->generic.devcaps.dwButtons = 128;
     }
 
-    newDevice->generic.base.IDirectInputDevice8A_iface.lpVtbl = &JoystickAvt;
-    newDevice->generic.base.IDirectInputDevice8W_iface.lpVtbl = &JoystickWvt;
-    newDevice->generic.base.ref = 1;
-    newDevice->generic.base.dinput = dinput;
-    newDevice->generic.base.guid = *rguid;
-    InitializeCriticalSection(&newDevice->generic.base.crit);
-    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
-
     /* setup_dinput_options may change these */
     newDevice->generic.deadzone = 0;
 
@@ -552,8 +542,6 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
         newDevice->generic.props[i].lSaturation = 0;
     }
 
-    IDirectInput_AddRef(&newDevice->generic.base.dinput->IDirectInput7A_iface);
-
     newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
     newDevice->generic.devcaps.dwFlags = DIDC_ATTACHED;
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 102de8269b9..4e1b3f83391 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -463,14 +463,10 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
     int default_axis_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS*2];
     DIDEVICEINSTANCEW ddi;
 
-    newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(JoystickImpl));
-    if (!newDevice) return NULL;
-
-    newDevice->generic.base.IDirectInputDevice8A_iface.lpVtbl = &JoystickAvt;
-    newDevice->generic.base.IDirectInputDevice8W_iface.lpVtbl = &JoystickWvt;
-    newDevice->generic.base.ref    = 1;
-    newDevice->generic.base.guid   = *rguid;
-    newDevice->generic.base.dinput = dinput;
+    if (FAILED(direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, &JoystickAvt, rguid, dinput, (void **)&newDevice)))
+        return NULL;
+    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
+
     newDevice->generic.joy_polldev = joy_polldev;
     newDevice->joyfd       = -1;
     newDevice->joydev      = &joydevs[index];
@@ -484,8 +480,6 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
        enabled. */
     newDevice->ff_autocenter = 1;
     newDevice->ff_gain = 0xFFFF;
-    InitializeCriticalSection(&newDevice->generic.base.crit);
-    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
 
     /* Count number of available axes - supported Axis & POVs */
     for (i = 0; i < ABS_MAX; i++)
@@ -593,8 +587,6 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
     if (newDevice->joydev->has_ff)
         newDevice->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
 
-    IDirectInput_AddRef(&newDevice->generic.base.dinput->IDirectInput7A_iface);
-
     return newDevice;
 
 failed:
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 4ec72465500..3631448ea78 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1096,12 +1096,9 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
 
-    newDevice = HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(JoystickImpl));
-    if (newDevice == 0) {
-        WARN("out of memory\n");
-        *pdev = 0;
-        return DIERR_OUTOFMEMORY;
-    }
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, &JoystickAvt, rguid, dinput, (void **)&newDevice)))
+        return hr;
+    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
 
     newDevice->id = index;
 
@@ -1163,14 +1160,6 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
         newDevice->generic.devcaps.dwButtons = 128;
     }
 
-    newDevice->generic.base.IDirectInputDevice8A_iface.lpVtbl = &JoystickAvt;
-    newDevice->generic.base.IDirectInputDevice8W_iface.lpVtbl = &JoystickWvt;
-    newDevice->generic.base.ref = 1;
-    newDevice->generic.base.dinput = dinput;
-    newDevice->generic.base.guid = *rguid;
-    InitializeCriticalSection(&newDevice->generic.base.crit);
-    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
-
     /* Create copy of default data format */
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto FAILED;
     memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
@@ -1240,8 +1229,6 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     /* initialize default properties */
     get_osx_device_elements_props(newDevice);
 
-    IDirectInput_AddRef(&newDevice->generic.base.dinput->IDirectInput7A_iface);
-
     newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
     newDevice->generic.devcaps.dwFlags |= DIDC_ATTACHED;
     if (newDevice->generic.base.dinput->dwVersion >= 0x0800)
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 9981372d957..46f0ce140e0 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -258,14 +258,10 @@ static SysKeyboardImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
     LPDIDATAFORMAT df = NULL;
     int i, idx = 0;
 
-    newDevice = HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(SysKeyboardImpl));
-    newDevice->base.IDirectInputDevice8A_iface.lpVtbl = &SysKeyboardAvt;
-    newDevice->base.IDirectInputDevice8W_iface.lpVtbl = &SysKeyboardWvt;
-    newDevice->base.ref = 1;
-    memcpy(&newDevice->base.guid, rguid, sizeof(*rguid));
-    newDevice->base.dinput = dinput;
-    InitializeCriticalSection(&newDevice->base.crit);
+    if (FAILED(direct_input_device_alloc(sizeof(SysKeyboardImpl), &SysKeyboardWvt, &SysKeyboardAvt, rguid, dinput, (void **)&newDevice)))
+        return NULL;
     newDevice->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": SysKeyboardImpl*->base.crit");
+
     newDevice->subtype = get_keyboard_subtype();
 
     /* Create copy of default data format */
@@ -288,8 +284,6 @@ static SysKeyboardImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
     df->dwNumObjs = idx;
 
     newDevice->base.data_format.wine_df = df;
-    IDirectInput_AddRef(&newDevice->base.dinput->IDirectInput7A_iface);
-
     return newDevice;
 
 failed:
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index e50731fda41..a741110419c 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -201,16 +201,11 @@ static SysMouseImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
     char buffer[20];
     HKEY hkey, appkey;
 
-    newDevice = HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(SysMouseImpl));
-    if (!newDevice) return NULL;
-    newDevice->base.IDirectInputDevice8A_iface.lpVtbl = &SysMouseAvt;
-    newDevice->base.IDirectInputDevice8W_iface.lpVtbl = &SysMouseWvt;
-    newDevice->base.ref = 1;
-    newDevice->base.dwCoopLevel = DISCL_NONEXCLUSIVE | DISCL_BACKGROUND;
-    newDevice->base.guid = *rguid;
-    InitializeCriticalSection(&newDevice->base.crit);
+    if (FAILED(direct_input_device_alloc(sizeof(SysMouseImpl), &SysMouseWvt, &SysMouseAvt, rguid, dinput, (void **)&newDevice)))
+        return NULL;
     newDevice->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": SysMouseImpl*->base.crit");
-    newDevice->base.dinput = dinput;
+
+    newDevice->base.dwCoopLevel = DISCL_NONEXCLUSIVE | DISCL_BACKGROUND;
 
     get_app_key(&hkey, &appkey);
     if (!get_config_key(hkey, appkey, "MouseWarpOverride", buffer, sizeof(buffer)))
@@ -237,8 +232,6 @@ static SysMouseImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
             df->rgodf[i].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
 
     newDevice->base.data_format.wine_df = df;
-    IDirectInput_AddRef(&newDevice->base.dinput->IDirectInput7A_iface);
-
     if (dinput->dwVersion >= 0x0800)
     {
         newDevice->base.use_raw_input = TRUE;
-- 
2.28.0

>From e214144f908df44c4dafada30208c41a899c1dfb Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 02/39] dinput: Factor IDirectInputDeviceA implementation.

As a IDirectInputDeviceW wrapper.
---
 dlls/dinput/Makefile.in           |   1 +
 dlls/dinput/ansi.c                | 562 ++++++++++++++++++++++++++++++
 dlls/dinput/device.c              | 255 +-------------
 dlls/dinput/device_private.h      |  63 +---
 dlls/dinput/joystick.c            | 159 ---------
 dlls/dinput/joystick_linux.c      |  73 +---
 dlls/dinput/joystick_linuxinput.c | 197 +----------
 dlls/dinput/joystick_osx.c        |  85 +----
 dlls/dinput/joystick_private.h    |  13 -
 dlls/dinput/keyboard.c            | 160 +--------
 dlls/dinput/mouse.c               | 168 +--------
 dlls/dinput8/Makefile.in          |   1 +
 12 files changed, 579 insertions(+), 1158 deletions(-)
 create mode 100644 dlls/dinput/ansi.c

